<?php
/*
 * 元宝支付 https://www.18pay.net
 * Date: 2020/12/10
 * Time: 15:38
 * 说明：
 * 以下代码只是为了方便商户测试而提供的样例代码，商户可以根据自己网站的需要，按照技术文档编写,并非一定要使用该代码。
 * 该代码仅供学习和研究接口使用，只是提供一个参考，最终解释权归美奇软件开发工作室所有。
 * 严禁一切钓鱼、色情、赌博、私彩及违反国家法律法规等使用。
 * 注意：
 * UTF-8编码不要在记事本下编辑，否则会出现一些奇葩的问题，正确方法应在开发工具里打开编辑
 */
ini_set("error_reporting","E_ALL & ~E_NOTICE");
header('Content-Type:application/json; charset=utf-8');
require "Des.php";
/////////////////需要修改的参数/////////////////
//商户编号
$appid = '填写平台的商户编号';
//商户密钥
$appkey = '填写平台的商户密钥';
//算法密钥
$deskey='填写平台的算法密钥';  
//数据库相关
define('DBUSER', 'sa');     //数据库用户名
define('DBPASS', '123456'); //数据库密码
//是否开启奖励（true开启，false关闭）
$award = true;
///////////////////////////////////////////////
//下面代码基本不需要修改
if (empty($_POST)) $_POST = $_GET;  //如果为GET方式访问
if(!isset($_POST['appid'])){
	outputError('参数非法');
}
//验证商户号
if($_POST['appid']!=$appid){
	outputError('商户编号不正确');
}
if (!function_exists('openssl_encrypt')){
	outputError('请开启php.ini的openssl扩展');
}
//解密接口参数
$des = new Des();
$parameter=$_POST['parameter'];
$decode=$des->decrypt($parameter,$deskey);
if(empty($decode)){
	outputError('算法密钥不正确');
}
parse_str($decode, $data);
//验证商户密钥
if($appkey!=$data['appkey']){
	outputError('商户密钥不正确');
}

//开始充值
chongzhi($data);
function chongzhi($data){
	//全局变量，函数内调用需要加global声明
	global $award;
	try{
		//游戏充值代码
		$account =  $data['account'];//帐号
		$money =  $data['money'];  //仙玉
		$scale = $data['scale'];  //比例
		$alias = $data['alias'];
		$dbname = $data['dbname'];  //数据库名
		$gold = $money*$scale;//游戏币=充值金额*充值比例
		//奖励
		$jiangli = array(
			100=>60,//满100送60  从小到大往下加
			200=>140,
			500=>400,
			1000=>1000,
		);
		$yuanbao_jl = 0;
		foreach ($jiangli as $key=>$value) {
			if($money>=$key){
				$yuanbao_jl = $value*$scale;
			}
		}
		$yuanbao = $award ? $gold+$yuanbao_jl :$gold;
		
		/*连接数据库*/
		$conInfo=array("Database"=>$dbname, "UID"=>DBUSER, "PWD"=>DBPASS);
		$conn=sqlsrv_connect("iZkamgh09lqugbZ", $conInfo);
		/*判断连接成功与否*/
		if( $conn == false ){
			$arr['code']=0;
			$arr['msg']="mssql连接失败";
		}else{
			$sql = "UPDATE Account SET yuanbao = yuanbao + ".$yuanbao." WHERE loginName = '".$account."'";
			$res=sqlsrv_query($conn,$sql);
			if($res){
				//成功后返回
				$text = $gold>=10000?($gold/10000).'万':$gold;
				$msg = sprintf("账号[%s]成功充值金额%s元，获得%s：%s个",$account,$money,$alias,$text);
				outputSuccess($msg);				
			}else{
				outputError("充值失败，错误代码：".$res);
			}	
		}
	} catch (\Exception $e) {
		outputError('充值异常，Error：'.$e->getMessage());
	}
}

function outputError($msg){
	$arr=array('code'=>0,'msg'=>$msg);
	echo json_encode($arr, JSON_UNESCAPED_UNICODE);
	exit;
}

function outputSuccess($msg){
	$arr=array('code'=>1,'msg'=>$msg);
	echo json_encode($arr, JSON_UNESCAPED_UNICODE);
	exit;
}

/** 
 * 打印日志
 * $msg 日志内容
 */
function printLog($msg) {
	if (!is_dir('log')){
		mkdir('log',0777,true);
	}
	$path="log/".date('Y-m-d').".log";
	file_put_contents($path, "【" . date('Y-m-d H:i:s') . "】" . $msg . "\r\n\r\n", FILE_APPEND);
}